<script setup>
import { computed, onMounted, reactive, ref } from "vue";
import Api from "../../api";
import TextInput from "../../components/ui/TextInput.vue";
import Button from "../../components/ui/Button.vue";
import { useRoute, useRouter } from "vue-router";
import { useStore } from "vuex";

const store = useStore();
let router = useRouter();
let route = useRoute();
const btnLoading = ref(false);
const form = reactive({
	email: "",
	password: "",
});
const errors = ref({});

onMounted(() => {
	if (route.query.email) {
		form.email = route.query.email;
	}
});

const submitForm = async () => {
	btnLoading.value = true;
	try {
		let res = await Api.getInstance().authService().login(form);
		if (res.status == 200) {
			localStorage.setItem("token", res.data.token);
			router.replace({ name: "Home" });
		}
	} catch (error) {
		if (error.response.status == 422) {
			errors.value = error.response.data.errors;
		}
		if (error.response.status == 401) {
			store.dispatch("notification/add", {
				text: error.response.data.message,
			});
		}
	}
	btnLoading.value = false;
};
</script>

<template>
	<div class="flex-center h-screen">
		<form @submit.prevent="submitForm" class="card flex-col">
			<h1 class="bold mb-2">Login</h1>
			<TextInput
				label="Email"
				placeholder="Enter your email address"
				v-model="form.email"
				:error="errors.email"
			/>
			<TextInput
				label="Password"
				placeholder="Enter your password"
				v-model="form.password"
				:error="errors.password"
			/>
			<div class="flex-center mt-1">
				<router-link :to="{ name: 'Register' }" class="fs8 register">
					Create new account?
				</router-link>
				<Button type="submit" :loading="btnLoading" class="ml-auto">
					Login
				</Button>
			</div>
		</form>
	</div>
</template>

<style scoped lang="scss">
.register {
	color: rgb(6, 80, 200);
}
</style>
